

-- Windows Definition
MB_ICONASTERISK = 64 -- Type for MessageBeep()
SW_SHOWNORMAL = 1

-- Timer
BEEP_TIMER_ID = 1000

nobeep_mode = 0

local function init_elem()
  local level = suilib.call('GetVolumeLevel')
  local mute = suilib.call('GetVolumeMuted')
  suilib.print(volume_slider)
  volume_slider.value = level
  vol_value.text = level

  if mute == 1 then
    vol_btn.selected = 0
    title_icon.bkimage="file='snd_mute.png'"
  else
    vol_btn.selected = 1
    title_icon.bkimage="file='snd.png'"
  end

  need_beep = 0
  suilib.call('KillTimer', BEEP_TIMER_ID)
  suilib.call('SetTimer', BEEP_TIMER_ID, 500)
end

function onload()
  require('lua_helper.lua_helper')

  vol_value = sui:find('vol_value')
  volume_slider = sui:find('volume_slider')
  suilib.print(volume_slider)
  vol_btn = sui:find('vol_btn')
  title_icon = sui:find('title')

  if string.find(os.getenv('SUI_PARAM'), '-nobeep') then
    nobeep_mode = 1
  end
  ui_path = sui:jcfg('name')
  LOADED = 1
  init_elem()
end

function onshow()
  if not LOADED then return end
  init_elem()
end

function onchanged(ctrl)
  if not LOADED then return end
  if ctrl == 'volume_slider' then
    local v = volume_slider.value
    local t = vol_value.text
    if tostring(v) ~= t then
      vol_value.text = v
      vol_changed = 1
    end
    if v == 0 then
      vol_btn.selected = 0
    else
      vol_btn.selected = 1
    end
  elseif ctrl == 'vol_btn' then
    local s = vol_btn.selected
    suilib.call('SetVolumeMute', s)
    if s == 1 then
      title_icon.bkimage="file='snd.png'"
    else
      title_icon.bkimage="file='snd_mute.png'"
    end
  end
end

UISTATE_CAPTURED = 64 -- Drag & Drop - ing

function ontimer(id)
  if id == BEEP_TIMER_ID then
    if sui:ishidden() == 1 then -- no need watch the slider change
      suilib.call('KillTimer', BEEP_TIMER_ID)
    end
    if vol_changed == 1 then
      suilib.call('SetVolumeLevel', volume_slider.value)
      if nobeep_mode == 0 and suilib.call('band', volume_slider.state, UISTATE_CAPTURED) == 0 then
        -- suilib.call('beep', MB_ICONASTERISK) -- don't work in PE 
        suilib.call('play', '.\\' .. ui_path .. '\\Windows Background.wav')
        vol_changed = 0
      end
    end
  end
end

local function hideme()
  sui:hide()
  suilib.call('KillTimer', BEEP_TIMER_ID)
end

function onclick(ctrl)
  if ctrl == 'sndvol_btn' then
    hideme()
    suilib.call('run', 'sndvol.exe', '-m 268439552', SW_SHOWNORMAL)
  elseif ctrl == 'closebtn' then
    hideme()
  end
end
